<?php

/*
 * Copyright (C) 2002-2012 AfterLogic Corp. (www.afterlogic.com)
 * Distributed under the terms of the license described in COPYING
 *
 */

/**
 * @package WebMail
 */
$aLangMap = array(
	'Calendar' => Calendar,
	'TitleDay' => TitleDay,
	'TitleWeek' => TitleWeek,
	'TitleMonth' => TitleMonth,
	'TitleEmail' => JS_LANG_Email,
	'TitleDelete' => JS_LANG_Delete,
	'ErrorNotSupportBrowser' => ErrorNotSupportBrowser,
	'ErrorTurnedOffActiveX' => ErrorTurnedOffActiveX,
	'CalendarTableDayMonday' => CalendarTableDayMonday,
	'CalendarTableDayTuesday' => CalendarTableDayTuesday,
	'CalendarTableDayWednesday' => CalendarTableDayWednesday,
	'CalendarTableDayThursday' => CalendarTableDayThursday,
	'CalendarTableDayFriday' => CalendarTableDayFriday,
	'CalendarTableDaySaturday' => CalendarTableDaySaturday,
	'CalendarTableDaySunday' => CalendarTableDaySunday,
	'FullMonthJanuary' => FullMonthJanuary,
	'FullMonthFebruary' => FullMonthFebruary,
	'FullMonthMarch' => FullMonthMarch,
	'FullMonthApril' => FullMonthApril,
	'FullMonthMay' => FullMonthMay,
	'FullMonthJune' => FullMonthJune,
	'FullMonthJuly' => FullMonthJuly,
	'FullMonthAugust' => FullMonthAugust,
	'FullMonthSeptember' => FullMonthSeptember,
	'FullMonthOctober' => FullMonthOctober,
	'FullMonthNovember' => FullMonthNovember,
	'FullMonthDecember' => FullMonthDecember,
	'ShortMonthJanuary' => ShortMonthJanuary,
	'ShortMonthFebruary' => ShortMonthFebruary,
	'ShortMonthMarch' => ShortMonthMarch,
	'ShortMonthApril' => ShortMonthApril,
	'ShortMonthMay' => ShortMonthMay,
	'ShortMonthJune' => ShortMonthJune,
	'ShortMonthJuly' => ShortMonthJuly,
	'ShortMonthAugust' => ShortMonthAugust,
	'ShortMonthSeptember' => ShortMonthSeptember,
	'ShortMonthOctober' => ShortMonthOctober,
	'ShortMonthNovember' => ShortMonthNovember,
	'ShortMonthDecember' => ShortMonthDecember,
	'AltPrevMonth' => AltPrevMonth,
	'AltNextMonth' => AltNextMonth,
	'TabDay' => TabDay,
	'TabWeek' => TabWeek,
	'TabMonth' => TabMonth,
	'SharePermission1' => SharePermission1,
	'SharePermission2' => SharePermission2,
	'SharePermission3' => SharePermission3,
	'SharePermission4' => SharePermission4,
	'FullDayMonday' => FullDayMonday,
	'FullDayTuesday' => FullDayTuesday,
	'FullDayWednesday' => FullDayWednesday,
	'FullDayThursday' => FullDayThursday,
	'FullDayFriday' => FullDayFriday,
	'FullDaySaturday' => FullDaySaturday,
	'FullDaySunday' => FullDaySunday,
	'InfoSaving' => InfoSaving,
	'ButtonCancel' => ButtonCancel,
	'ButtonSave' => ButtonSave,
	'CalendarHeaderNew' => CalendarHeaderNew,
	'CalendarHeaderEdit' => CalendarHeaderEdit,
	'CalendarActionEdit' => CalendarActionEdit,
	'ConfirmAreYouSure' => JS_LANG_ConfirmAreYouSure,
	'ConfirmDeleteCalendar' => ConfirmDeleteCalendar,
	'ConfirmUnsubscribeCalendar' => ConfirmUnsubscribeCalendar,
	'InfoDeleting' => InfoDeleting,
	'WarningCalendarNameBlank' => WarningCalendarNameBlank,
	'ErrorCalendarNotCreated' => ErrorCalendarNotCreated,
	'WarningSubjectBlank' => WarningSubjectBlank,
	'WarningIncorrectTime' => WarningIncorrectTime,
	'WarningIncorrectFromTime' => WarningIncorrectFromTime,
	'WarningIncorrectTillTime' => WarningIncorrectTillTime,
	'WarningStartEndDate' => WarningStartEndDate,
	'WarningStartEndTime' => WarningStartEndTime,
	'WarningIncorrectDate' => WarningIncorrectDate,
	'WarningEmailFieldFilling' => WarningEmailFieldFilling,
	'InfoLoading' => InfoLoading,
	'EventCreate' => EventCreate,
	'CalendarHideOther' => CalendarHideOther,
	'CalendarShowOther' => CalendarShowOther,
	'CalendarRemove' => CalendarRemove,
	'CalendarUnsubscribe' => CalendarUnsubscribe,
	'InfoUnsubscribing' => InfoUnsubscribing,
	'EventHeaderNew' => EventHeaderNew,
	'EventHeaderEdit' => EventHeaderEdit,
	'EventHeaderView' => EventHeaderView,
	'ShareActionEdit' => ShareActionEdit,
	'ShareHeaderEdit' => ShareHeaderEdit,
	'DayToolMonday' => DayToolMonday,
	'DayToolTuesday' => DayToolTuesday,
	'DayToolWednesday' => DayToolWednesday,
	'DayToolThursday' => DayToolThursday,
	'DayToolFriday' => DayToolFriday,
	'DayToolSaturday' => DayToolSaturday,
	'DayToolSunday' => DayToolSunday,
	'ErrorLoadCalendar' => ErrorLoadCalendar,
	'ErrorLoadEvents' => ErrorLoadEvents,
	'ErrorUpdateEvent' => ErrorUpdateEvent,
	'ErrorDeleteEvent' => ErrorDeleteEvent,
	'ErrorUpdateCalendar' => ErrorUpdateCalendar,
	'ErrorDeleteCalendar' => ErrorDeleteCalendar,
	'ErrorUpdateSharing1' => ErrorUpdateSharing1,
	'ErrorUpdateSharing2' => ErrorUpdateSharing2,
	'ErrorUpdateSharing3' => ErrorUpdateSharing3,
	'ErrorGetPublicationHash ' => ErrorGetPublicationHash,
	'ErrorGeneral' => ErrorGeneral,
	'ErrorGetSharing' => ErrorGetSharing,
	'WarningCorrectEmail' => JS_LANG_WarningCorrectEmail,
	'CalendarPublishedTitle' => CalendarPublishedTitle,
	'SharedTitleEmail' => SharedTitleEmail,
	'RefreshSharedCalendars' => RefreshSharedCalendars,
	'MonthMoreLink' => MonthMoreLink,
	'OneNewSharedCalendars' => OneNewSharedCalendars,
	'NNewSharedCalendars' => NNewSharedCalendars,
	'NoNewSharedCalendars' => NoNewSharedCalendars,
	'ConfirmUndoOneRepeat' => ConfirmUndoOneRepeat,
	'RepeatEveryDayInfin' => RepeatEveryDayInfin,
	'RepeatEveryDayTimes' => RepeatEveryDayTimes,
	'RepeatEveryDayUntil' => RepeatEveryDayUntil,
	'RepeatDaysInfin' => RepeatDaysInfin,
	'RepeatDaysTimes' => RepeatDaysTimes,
	'RepeatDaysUntil' => RepeatDaysUntil,
	'RepeatEveryWeekInfin' => RepeatEveryWeekInfin,
	'RepeatEveryWeekTimes' => RepeatEveryWeekTimes,
	'RepeatEveryWeekUntil' => RepeatEveryWeekUntil,
	'RepeatWeeksInfin' => RepeatWeeksInfin,
	'RepeatWeeksTimes' => RepeatWeeksTimes,
	'RepeatWeeksUntil' => RepeatWeeksUntil,
	'RepeatEveryMonthDateInfin' => RepeatEveryMonthDateInfin,
	'RepeatEveryMonthDateTimes' => RepeatEveryMonthDateTimes,
	'RepeatEveryMonthDateUntil' => RepeatEveryMonthDateUntil,
	'RepeatMonthsDateInfin' => RepeatMonthsDateInfin,
	'RepeatMonthsDateTimes' => RepeatMonthsDateTimes,
	'RepeatMonthsDateUntil' => RepeatMonthsDateUntil,
	'RepeatEveryMonthWDInfin' => RepeatEveryMonthWDInfin,
	'RepeatEveryMonthWDTimes' => RepeatEveryMonthWDTimes,
	'RepeatEveryMonthWDUntil' => RepeatEveryMonthWDUntil,
	'RepeatMonthsWDInfin' => RepeatMonthsWDInfin,
	'RepeatMonthsWDTimes' => RepeatMonthsWDTimes,
	'RepeatMonthsWDUntil' => RepeatMonthsWDUntil,
	'RepeatEveryYearDateInfin' => RepeatEveryYearDateInfin,
	'RepeatEveryYearDateTimes' => RepeatEveryYearDateTimes,
	'RepeatEveryYearDateUntil' => RepeatEveryYearDateUntil,
	'RepeatYearsDateInfin' => RepeatYearsDateInfin,
	'RepeatYearsDateTimes' => RepeatYearsDateTimes,
	'RepeatYearsDateUntil' => RepeatYearsDateUntil,
	'RepeatEveryYearWDInfin' => RepeatEveryYearWDInfin,
	'RepeatEveryYearWDTimes' => RepeatEveryYearWDTimes,
	'RepeatEveryYearWDUntil' => RepeatEveryYearWDUntil,
	'RepeatYearsWDInfin' => RepeatYearsWDInfin,
	'RepeatYearsWDTimes' => RepeatYearsWDTimes,
	'RepeatYearsWDUntil' => RepeatYearsWDUntil,
	'RepeatDescDay' => RepeatDescDay,
	'RepeatDescWeek' => RepeatDescWeek,
	'RepeatDescMonth' => RepeatDescMonth,
	'RepeatDescYear' => RepeatDescYear,
	'First' => First,
	'Second' => Second,
	'Third' => Third,
	'Fourth' => Fourth,
	'Last' => Last,
	'WarningUntilDateBlank' => WarningUntilDateBlank,
	'WarningWrongUntilDate' => WarningWrongUntilDate,
	'NoEndRepeatEvent' => NoEndRepeatEvent,
	'EndRepeatEventBy' => EndRepeatEventBy,
	'EndRepeatEventAfter' => EndRepeatEventAfter,
	'Occurrences' => Occurrences,
	'Every' => Every,
	'ReminderNone' => ReminderNone,
	'ReminderMinutes' => ReminderMinutes,
	'ReminderHour' => ReminderHour,
	'ReminderHours' => ReminderHours,
	'ReminderDay' => ReminderDay,
	'ReminderDays' => ReminderDays,
	'ReminderWeek' => ReminderWeek,
	'ReminderWeeks' => ReminderWeeks,
	'Allday' => Allday,
	'Remove' => JS_LANG_Remove,
	'AddReminder' => AddReminder,
	'AddMoreReminder' => AddMoreReminder,
	'AddReminderBefore' => AddReminderBefore,
	'AddReminderAnd' => AddReminderAnd,
	'AddReminderAlso' => AddReminderAlso,
	'AppointmentInvalidGuestEmail' => AppointmentInvalidGuestEmail,
	'AppointmentOrganizer' => AppointmentOrganizer,
	'AppointmentRespondYes' => AppointmentRespondYes,
	'AppointmentHaventRespond' => AppointmentHaventRespond,
	'AppointmentRespondMaybe' => AppointmentRespondMaybe,
	'AppointmentRespondNo' => AppointmentRespondNo,
	'ReportEventSaved' => ReportEventSaved,
	'ReportAppointmentSaved' => ReportAppointmentSaved,
	'ErrorAppointmentSend' => ErrorAppointmentSend,
	'ErrorAppointmentChangeRespond' => ErrorAppointmentChangeRespond,
	'ReportCalendarSaved' => ReportCalendarSaved,
	'ConfirmEditRepeatEvent' => ConfirmEditRepeatEvent,
	'ConfirmEditRepeatEventNotDaily' => ConfirmEditRepeatEventNotDaily
);
